﻿using UnityEngine;


/// <summary>
/// 自機
/// </summary>
public class Fighter : MonoBehaviour {
	/// <summary>
	/// 初期化
	/// </summary>
	private void Start() {
		// 自機の座標をコードから初期化する（おまけ）
		this.transform.position = new Vector3(0f, 0f, -5f);
	}

	/// <summary>
	/// 毎フレームの更新
	/// </summary>
	private void Update() {
		float elapsedTime = Time.deltaTime;

// Editor上とPCビルドとWebGLビルドはマウス処理
#if UNITY_EDITOR || UNITY_STANDALONE || UNITY_WEBGL
		// 左ボタン（0番）を"押している"際の処理
		if (Input.GetMouseButton(0)) {
			this.transform.position = this.GetScreen2WorldPosition(Input.mousePosition);
		}
#else
		if (Input.touchCount > 0) {
			// タッチ入力が存在している場合の0番の座標を取得
			Touch touch = Input.GetTouch(0);
			this.transform.position = this.GetScreen2WorldPosition(touch.position);
		}
#endif
	}

	/// <summary>
	/// スクリーン座標からワールド座標を求める
	/// </summary>
	/// <param name="screenPosition">入力スクリーン座標</param>
	/// <returns>入力地点のワールド座標</returns>
	private Vector3 GetScreen2WorldPosition(Vector3 screenPosition) {
		screenPosition.z = Camera.main.transform.position.y;
		return Camera.main.ScreenToWorldPoint(screenPosition);
	}
}
